Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.opensymphony.xwork2.interceptor
Class ParametersInterceptor

    java.lang.Object
      com.opensymphony.xwork2.interceptor.AbstractInterceptor
          com.opensymphony.xwork2.interceptor.MethodFilterInterceptor
              com.opensymphony.xwork2.interceptor.ParametersInterceptor

All Implemented Interfaces:
  Interceptor, Serializable

    public class ParametersInterceptor

extends MethodFilterInterceptor

This interceptor sets all parameters on the value stack. This interceptor gets all parameters from `ActionContext.getParameters()` and sets them on the value stack by calling `ValueStack.setValue(String, Object)`, typically resulting in the values submitted in a form request being applied to an action in the value stack. Note that the parameter map must contain a String key and often containers a String[] for the value. The interceptor takes one parameter named 'ordered'. When set to true action properties are guaranteed to be set top-down which means that top action's properties are set first. Then it's subcomponents properties are set. The reason for this order is to enable a 'factory' pattern. For example, let's assume that one has an action that contains a property named 'modelClass' that allows to choose what is the underlying implementation of model. By assuring that modelClass property is set before any model properties are set, it's possible to choose model implementation during action.setModelClass() call. Similiarily it's possible to use action.setPrimaryKey() property set call to actually load the model class from persistent storage. Without any assumption on parameter order you have to use patterns like 'Preparable'. Because parameter names are effectively OGNL statements, it is important that security be taken in to account. This interceptor will not apply any values in the parameters map if the expression contains an assignment (=), multiple expressions (,), or references any objects in the context (#). This is all done in the `acceptableName(String)` method. In addition to this method, if the action being invoked implements the `ParameterNameAware` interface, the action will be consulted to determine if the parameter should be set. In addition to these restrictions, a flag (`ReflectionContextState.DENY_METHOD_EXECUTION`) is set such that no methods are allowed to be invoked. That means that any expression such as person.doSomething() or person.getName() will be explicitely forbidden. This is needed to make sure that your application is not exposed to attacks by malicious users. While this interceptor is being invoked, a flag (`ReflectionContextState.CREATE_NULL_OBJECTS`) is turned on to ensure that any null reference is automatically created - if possible. See the type conversion documentation and the `InstantiatingNullHandler` javadocs for more information. Finally, a third flag (`XWorkConverter.REPORT_CONVERSION_ERRORS`) is set that indicates any errors when converting the the values to their final data type (String[] -> int) an unrecoverable error occured. With this flag set, the type conversion errors will be reported in the action context. See the type conversion documentation and the `XWorkConverter` javadocs for more information. If you are looking for detailed logging information about your parameters, turn on DEBUG level logging for this interceptor. A detailed log of all the parameter keys and values will be reported. Note: Since XWork 2.0.2, this interceptor extends `MethodFilterInterceptor`, therefore being able to deal with excludeMethods / includeMethods parameters. See [Workflow Interceptor] (class `DefaultWorkflowInterceptor`) for documentation and examples on how to use this feature. Interceptor parameters:

- ordered - set to true if you want the top-down property setter behaviour
- acceptParamNames - a comma delimited list of regular expressions to describe a whitelist of accepted parameter names. Don't change the default unless you know what you are doing in terms of security implications
- excludeParams - a comma delimited list of regular expressions to describe a blacklist of not allowed parameter names
- paramNameMaxLength - the maximum length of parameter names; parameters with longer names will be ignored; the default is 100 characters

Extending the interceptor: The best way to add behavior to this interceptor is to utilize the `ParameterNameAware` interface in your actions. However, if you wish to apply a global rule that isn't implemented in your action, then you could extend this interceptor and override the `acceptableName(String)` method. Using `ParameterNameAware` could be dangerous as `ParameterNameAware.acceptableParameterName(String)` takes precedence over ParametersInterceptor which means if ParametersInterceptor excluded given parameter name you can accept it with `ParameterNameAware.acceptableParameterName(String)`. The best idea is to define very tight restrictions with ParametersInterceptor and relax them per action with `ParameterNameAware.acceptableParameterName(String)` Example code:

     <action name="someAction" class="com.examples.SomeAction">
         <interceptor-ref name="params"/>
         <result name="success">good_result.ftl</result>
     </action>

Author:
  Patrick Lightbody
See Also:
  Serialized Form

Field Summary
`protected boolean` | `ordered`
`protected static int` | `PARAM_NAME_MAX_LENGTH`

Fields inherited from class com.opensymphony.xwork2.interceptor.MethodFilterInterceptor
`excludeMethods, includeMethods, log`

Constructor Summary
`ParametersInterceptor()`

Method Summary
`protected boolean` | `acceptableName(String name)`
`protected void` | `addParametersToContext(ActionContext ac, Map<String,Object> newParams)` Adds the parameters into context's ParameterMap
`String` | `doIntercept(ActionInvocation invocation)` Subclasses must override to implement the interceptor logic.
`protected Comparator<String>` | `getOrderedComparator()` Gets an instance of the comparator to use for the ordered sorting.
`protected String` | `getParameterLogMap(Map<String,Object> parameters)`
`protected boolean` | `isAcceptableParameter(String name, Object action)` Checks if name of parameter can be accepted or thrown away
`protected boolean` | `isAccepted(String paramName)`
`protected boolean` | `isExcluded(String paramName)`
`boolean` | `isOrdered()` Whether to order the parameters or not
`protected boolean` | `isWithinLengthLimit(String name)`
`protected void` | `notifyDeveloperParameterException(Object action, String property, String message)`
`protected Map<String,Object>` | `retrieveParameters(ActionContext ac)` Gets the parameter map to apply from wherever appropriate
`void` | `setAcceptedPatterns(AcceptedPatternsChecker acceptedPatterns)`
`void` | `setAcceptParamNames(String commaDelim)` Sets a comma-delimited list of regular expressions to match parameters that are allowed in the parameter map (aka whitelist).
`void` | `setDevMode(String mode)`
`void` | `setExcludedPatterns(ExcludedPatternsChecker excludedPatterns)`
`void` | `setExcludeParams(String commaDelim)` Sets a comma-delimited list of regular expressions to match parameters that should be removed from the parameter map.
`void` | `setOrdered(boolean ordered)` Set whether to order the parameters by object depth or not
`protected void` | `setParameters(Object action, ValueStack stack, Map<String,Object> parameters)`
`void` | `setParamNameMaxLength(int paramNameMaxLength)` If the param name exceeds the configured maximum length it will not be accepted.
`void` | `setValueStackFactory(ValueStackFactory valueStackFactory)`

Methods inherited from class com.opensymphony.xwork2.interceptor.MethodFilterInterceptor
`applyInterceptor, getExcludeMethodsSet, getIncludeMethodsSet, intercept, setExcludeMethods, setIncludeMethods`

Methods inherited from class com.opensymphony.xwork2.interceptor.AbstractInterceptor
`destroy, init`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PARAM_NAME_MAX_LENGTH

    protected static final int PARAM_NAME_MAX_LENGTH

See Also:
  Constant Field Values

### ordered

    protected boolean ordered

Constructor Detail

### ParametersInterceptor

    public ParametersInterceptor()

Method Detail

### setValueStackFactory

    public void setValueStackFactory(ValueStackFactory valueStackFactory)

### setDevMode

    public void setDevMode(String mode)

### setExcludedPatterns

    public void setExcludedPatterns(ExcludedPatternsChecker excludedPatterns)

### setAcceptedPatterns

    public void setAcceptedPatterns(AcceptedPatternsChecker acceptedPatterns)

### setParamNameMaxLength

    public void setParamNameMaxLength(int paramNameMaxLength)

  If the param name exceeds the configured maximum length it will not be accepted.

  Parameters:
    `paramNameMaxLength` - Maximum length of param names

### doIntercept

    public String doIntercept(ActionInvocation invocation)
                       throws Exception

  Description copied from class: `MethodFilterInterceptor`
  Subclasses must override to implement the interceptor logic.

  Specified by:
    `doIntercept` in class `MethodFilterInterceptor`
  Parameters:
    `invocation` - the action invocation
  Returns:
    the result of invocation
  Throws:
    `Exception`

### retrieveParameters

    protected Map<String,Object> retrieveParameters(ActionContext ac)

  Gets the parameter map to apply from wherever appropriate

  Parameters:
    `ac` - The action context
  Returns:
    The parameter map to apply

### addParametersToContext

    protected void addParametersToContext(ActionContext ac,
                                          Map<String,Object> newParams)

  Adds the parameters into context's ParameterMap

  Parameters:
    `ac` - The action context
    `newParams` - The parameter map to apply

    In this class this is a no-op, since the parameters were fetched from the same location. In subclasses both retrieveParameters() and addParametersToContext() should be overridden.

### setParameters

    protected void setParameters(Object action,
                                 ValueStack stack,
                                 Map<String,Object> parameters)

### notifyDeveloperParameterException

    protected void notifyDeveloperParameterException(Object action,
                                                     String property,
                                                     String message)

### isAcceptableParameter

    protected boolean isAcceptableParameter(String name,
                                            Object action)

  Checks if name of parameter can be accepted or thrown away

  Parameters:
    `name` - parameter name
    `action` - current action
  Returns:
    true if parameter is accepted

### getOrderedComparator

    protected Comparator<String> getOrderedComparator()

  Gets an instance of the comparator to use for the ordered sorting. Override this method to customize the ordering of the parameters as they are set to the action.

  Returns:
    A comparator to sort the parameters

### getParameterLogMap

    protected String getParameterLogMap(Map<String,Object> parameters)

### acceptableName

    protected boolean acceptableName(String name)

### isWithinLengthLimit

    protected boolean isWithinLengthLimit(String name)

### isAccepted

    protected boolean isAccepted(String paramName)

### isExcluded

    protected boolean isExcluded(String paramName)

### isOrdered

    public boolean isOrdered()

  Whether to order the parameters or not

  Returns:
    True to order

### setOrdered

    public void setOrdered(boolean ordered)

  Set whether to order the parameters by object depth or not

  Parameters:
    `ordered` - True to order them

### setAcceptParamNames

    public void setAcceptParamNames(String commaDelim)

  Sets a comma-delimited list of regular expressions to match parameters that are allowed in the parameter map (aka whitelist).

  Don't change the default unless you know what you are doing in terms of security implications.

  Parameters:
    `commaDelim` - A comma-delimited list of regular expressions

### setExcludeParams

    public void setExcludeParams(String commaDelim)

  Sets a comma-delimited list of regular expressions to match parameters that should be removed from the parameter map.

  Parameters:
    `commaDelim` - A comma-delimited list of regular expressions

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000–2018 Apache Software Foundation. All rights reserved.